//Warren Fong
//CSC 290
//Secure Chat

import java.net.*;
import java.io.*;
import java.math.BigInteger;

public class ChatServerThread extends Thread
{  private ChatServer       server    = null;
   private Socket           socket    = null;
   private int              ID        = -1;
   private int user1 = 0;
   private DataInputStream  streamIn  =  null;
   private DataOutputStream streamOut = null;
   private BigInteger pubKeyA, pubKeyB;
   private String UserName;
   public ChatServerThread(ChatServer _server, Socket _socket)
   {  super();
      server = _server;
      socket = _socket;
      ID     = socket.getPort();
      
   }
   public void send(String msg)
   {   try
       {   
          streamOut.writeUTF(msg);
          streamOut.flush();
       }
       catch(IOException ioe)
       {  System.out.println(ID + " ERROR sending: " + ioe.getMessage());
          server.remove(ID);
          stop();
       }
   }
   public int getID()
   {  return ID;
   }
   public String getUserName()
   {  
       return UserName;
   }
   public void run()
   {  System.out.println("Server Thread " + ID + " running.");
      while (true)
       {  
           try
           {  
              if(user1 == 0){
               server.initialStor(streamIn.readUTF());
               UserName = server.UserName;
               server.pubKeyStor(streamIn.readUTF());
               server.pubEStor(streamIn.readUTF());
               user1 = 1; 
              }else {
               server.handle(ID, streamIn.readUTF());
              }
           }
           catch(IOException ioe)
         {  System.out.println(ID + " ERROR reading: " + ioe.getMessage());
            server.remove(ID);
            stop();
         }
      }
   }
   public void open() throws IOException
   {  streamIn = new DataInputStream(new 
                        BufferedInputStream(socket.getInputStream()));
      streamOut = new DataOutputStream(new
                        BufferedOutputStream(socket.getOutputStream()));
   }
   public void close() throws IOException
   {  if (socket != null)    socket.close();
      if (streamIn != null)  streamIn.close();
      if (streamOut != null) streamOut.close();
   }
}

