//Warren Fong
//CSC 290
//Secure Chat

import java.math.BigInteger;
import java.security.SecureRandom;

class Rsa {
    private BigInteger n, d, e, P, Q, N, M, E, D;
    BigInteger Nvalue,Evalue,Dvalue;
    public Rsa(){
        
    }
    public Rsa(int bitlen) {
        Rsa test = new Rsa();
        P = test.genPrime(bitlen/2, 100);
        Q = test.genPrime(bitlen/2, 100);
        while(P.compareTo(Q) == 0) {
            Q = test.genPrime(bitlen/2, 100);
        }
        //System.out.println("P \t:"+P);
        //System.out.println("Q \t:"+Q);
        N = P.multiply(Q);
        //System.out.println("N \t:"+N);
        Nvalue = N;
        M = (P.subtract(BigInteger.ONE)).multiply(Q.subtract(BigInteger.ONE));
        //System.out.println("M \t:"+M);
        E = new BigInteger("3");
        while(M.gcd(E).intValue() > 1) {
            E = E.add(new BigInteger("2"));
        }
        System.out.println("E \t:"+E);
        Evalue = E;
        D = E.modInverse(M);
        System.out.println("D \t:"+D);
        Dvalue = D;
    }
    public BigInteger encrypt(BigInteger message,BigInteger eval, BigInteger nval) {
        //System.out.println("their: "+message.modPow(eval,nval));
        BigInteger result = fastExp(message, eval, nval);
        //System.out.println("myresult: "+result);
        return result;
    }
    public BigInteger decrypt(BigInteger message,BigInteger dval, BigInteger nval) {
        //System.out.println("their: "+message.modPow(dval,nval));
        BigInteger result = fastExp(message, dval, nval);
        //System.out.println("myresult\t:"+result);
        return result;
    }
    //Euclid Algorithm
    public BigInteger gcd(BigInteger a, BigInteger b){
        if (b.compareTo(BigInteger.ZERO) == 0)return a;
        else return gcd(b,a.mod(b));
    }
    //Fast Exponentiation
    public BigInteger fastExp(BigInteger x, BigInteger e, BigInteger y){
        BigInteger result = BigInteger.ONE;
        BigInteger two = new BigInteger("2");
        while(e.compareTo(BigInteger.ZERO) > 0) {
            if(e.mod(two).compareTo(BigInteger.ZERO) == 0){
                x = (x.multiply(x)).mod(y);
                e = e.divide(two);
            }else{
                result = (x.multiply(result)).mod(y);
                e = e.subtract(BigInteger.ONE);
        }
        }
        return result;
    }
    
    //Miller Rabin primality Tests
    public int primeT(BigInteger pvalue) {
        BigInteger [] qandm = getqandm(pvalue);
        BigInteger qval =qandm[0];
        BigInteger neg = new BigInteger("-1");
        if (qval.compareTo(neg)==0)return 0;
        SecureRandom r = new SecureRandom();
        BigInteger bvalue = new BigInteger(pvalue.bitLength(),r);
        BigInteger mvalue =qandm[1];
        BigInteger two = new BigInteger("2");
        BigInteger pminusone = pvalue.subtract(BigInteger.ONE);
        if (bvalue.modPow(mvalue,pvalue).compareTo(BigInteger.ONE)==0)return 1;
        BigInteger j = BigInteger.ZERO;
        BigInteger indexvalue = mvalue;
        while (j.compareTo(qval)<0) {
            if (pminusone.compareTo(bvalue.modPow(indexvalue,pvalue))==0)return 1;
            indexvalue = indexvalue.multiply(two);
            j = j.add(BigInteger.ONE);
        }
        return 0;
    }
    
    public BigInteger genPrime(int bitlen, int num) {
        SecureRandom r = new SecureRandom();
        BigInteger p = new BigInteger(bitlen,r);
        int i = 0;
        while(i < num) {
            if(primeT(p)==0)break;
            else i++;
        }
        if(i==num)return p;
        else return genPrime(bitlen, num);
    }
    
    public BigInteger [] getqandm(BigInteger p) {
        p = p.subtract(BigInteger.ONE);
        BigInteger two = new BigInteger("2");
        BigInteger neg = new BigInteger("-1");
        BigInteger [] result ={BigInteger.ZERO, BigInteger.ZERO}; 
        if (p.mod(two).compareTo(BigInteger.ZERO) != 0) {
            result[0] = neg; result[1] = neg;
            return result;
        }
        BigInteger divisor = p.divide(two);
        BigInteger counter = BigInteger.ONE;
        while (divisor.mod(two).compareTo(BigInteger.ZERO)==0) {
            counter = counter.add(BigInteger.ONE);
            divisor = divisor.divide(two);
        }
        result[0] = counter; result[1] = divisor;
        return result;
    }
}

